import 'package:tencent_calls_engine/tencent_calls_engine.dart';
import 'package:tencent_calls_uikit/src/tuicall_engine_manager.dart';
import 'package:tencent_calls_uikit/src/tuicall_state.dart';
import 'package:tencent_calls_uikit/tuicall_kit.dart';
import 'package:tencent_cloud_uikit_core/tencent_cloud_uikit_core.dart';

class TUICallKitImpl extends TUICallKit {
  @override
  Future<TUIResult> login(int sdkAppId, String userId, String userSig) async {
    TUIResult result = TUIResult(code: '', message: 'success');
    await TUILogin.instance.login(
        sdkAppId,
        userId,
        userSig,
        TUICallback(onSuccess: () {
        }, onError: (code, message) {
          result = TUIResult(code: "${code}", message: message);
        }));
    return result;
  }

  @override
  Future<void> logout() async {
    await TUILogin.instance.logout(
        TUICallback(onSuccess: () {
        }, onError: (code, message) {}));
  }

  @override
  Future<TUIResult> setSelfInfo(String nickname, String avatar) {
    return TUICallEngienManager.instance.setSelfInfo(nickname, avatar);
  }

  @override
  Future<void> call(String userId, TUICallMediaType callMediaType,
      [TUICallParams? params]) {
    return TUICallEngienManager.instance.call(userId, callMediaType, params);
  }

  @override
  Future<void> groupCall(
      String groupId, List<String> userIdList, TUICallMediaType callMediaType,
      [TUICallParams? params]) {
    return TUICallEngienManager.instance
        .groupCall(groupId, userIdList, callMediaType, params);
  }

  @override
  Future<void> joinInGroupCall(
      TUIRoomId roomId, String groupId, TUICallMediaType callMediaType) {
    return TUICallEngienManager.instance
        .joinInGroupCall(roomId, groupId, callMediaType);
  }

  @override
  Future<void> enableFloatWindow(bool enable) async {
    TUICallState.instance.enableFloatWindow = enable;
  }

  @override
  Future<void> enableMuteMode(bool enable) {
    return TUICallEngienManager.instance.enableMuteMode(enable);
  }
}
