import 'package:tencent_calls_engine/tencent_calls_engine.dart';
import 'package:tencent_cloud_uikit_core/tencent_cloud_uikit_core.dart';

class PermissionRequest {
  static String getPermissionRequestTitle(TUICallMediaType type) {
    return "request";
  }

  static String getPermissionRequestDescription(TUICallMediaType type) {
    return "Description";
  }

  static String getPermissionRequestSettingsTip(TUICallMediaType type) {
    return "SettingsTip";
  }

  static Future<TUIPermissionResult> checkCallingPermission(
      TUICallMediaType type) async {
    TUIPermissionResult result = TUIPermissionResult.denied;
    if (TUICallMediaType.video == type) {
      result = await TUIPermission.request(
          permissions: [TUIPermissions.camera, TUIPermissions.microphone],
          title: getPermissionRequestTitle(type),
          description: getPermissionRequestDescription(type),
          settingsTip: getPermissionRequestDescription(type));
    } else {
      result = await TUIPermission.request(
          permissions: [TUIPermissions.microphone],
          title: getPermissionRequestTitle(type),
          description: getPermissionRequestDescription(type),
          settingsTip: getPermissionRequestDescription(type));
    }
    return result;
  }
}
